BlumBlumShub Class Reference

BlumBlumShub with factorization of the modulus. More...

Inheritance diagram for BlumBlumShub:

## Public Member Functions

| BlumBlumShub (const Integer &p, const Integer &q, const Integer &seed)
bool | IsRandomAccess () const
| Determines whether the cipher supports random access. More...
void | Seek (lword index)
| Seek to an absolute position. More...
Public Member Functions inherited from PublicBlumBlumShub
| PublicBlumBlumShub (const Integer &n, const Integer &seed)
unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
byte | GenerateByte ()
| Generate new random byte and return it. More...
void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction. More...
Public Member Functions inherited from RandomNumberGenerator
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
virtual void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...

## Detailed Description

BlumBlumShub with factorization of the modulus.

Definition at line 42 of file blumshub.h.

## Member Function Documentation

## IsRandomAccess()

bool BlumBlumShub::IsRandomAccess | ( |  | ) | const

inline virtual

Determines whether the cipher supports random access.

Returns
  true if the cipher supports random access, false otherwise

Implements StreamTransformation.

Definition at line 49 of file blumshub.h.

## Seek()

void BlumBlumShub::Seek | ( | lword | pos | ) |

virtual

Seek to an absolute position.

Parameters

  pos | position to seek

Exceptions

  NotImplemented |

The base class implementation throws NotImplemented. The function asserts IsRandomAccess() in debug builds.

Reimplemented from StreamTransformation.

Definition at line 55 of file blumshub.cpp.

The documentation for this class was generated from the following files:

- blumshub.h
- blumshub.cpp